<?php
/**
 * webtrees: online genealogy
 * Copyright (C) 2015 webtrees development team
 * Copyright (C) 2015 JustCarmen
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
namespace Andre\WebtreesAddOn\Sosa\Schema;

use Fisharebest\Webtrees\Database;
use Fisharebest\Webtrees\I18N;
use Fisharebest\Webtrees\Schema\MigrationInterface;
use Fisharebest\Webtrees\Tree;


/**
 * Upgrade the database schema from version 0 to version 1.
 */
class Migration0 implements MigrationInterface {

	/** {@inheritDoc} */
	public function upgrade() {		
	//Initialiser avec I0 et envoyer sur chooseDeCujus
		$sosa_settings = Database::prepare("
				CREATE TABLE IF NOT EXISTS `##sosa` (
				 `sosa_id` int(11) NOT NULL AUTO_INCREMENT,
				 `sosa_xref` varchar(11) NOT NULL,
				 `sosa_num` int(11) NOT NULL,
				 `sosa_gen` int(11) NOT NULL,
				 `sosa_gid` int(11) NOT NULL,
				 PRIMARY KEY (`sosa_id`),
				 UNIQUE KEY `sosa_id` (`sosa_id`)
				) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=2 ;
				")->execute();
		// fin creation table
			
	}

}
