<?php
/**
 * webtrees: online genealogy
 * Copyright (C) 2015 webtrees development team
 * Copyright (C) 2015 JustCarmen
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
namespace Andre\WebtreesAddOn\Sosa\Schema;

use Fisharebest\Webtrees\Database;
use Fisharebest\Webtrees\I18N;
use Fisharebest\Webtrees\Schema\MigrationInterface;
use Fisharebest\Webtrees\Tree;
use Fisharebest\Webtrees\Log;



/**
 * Upgrade the database schema from version 1 to version 2.
 */
class Migration1 implements MigrationInterface {

	/** {@inheritDoc} */
	public function upgrade() {		
	$module_name = 'sosa';
	//Initialiser Navigation bar true
	$rows = Database::prepare("SELECT * FROM `##module_setting` WHERE setting_name ='SOSA_NAVIGATION_BAR' AND module_name = 'sosa'")->execute()->fetchOne();
		if (!$rows) {
			Database::prepare(
			"INSERT INTO `##module_setting` (module_name, setting_name, setting_value) VALUES (?, ?, ?)")->execute(array($module_name, 'SOSA_NAVIGATION_BAR', true));
			Log::addConfigurationLog('sosa create navigation bar true');			
		} else {
			Database::prepare(
			"UPDATE `##module_setting` SET setting_value=? WHERE setting_name=? AND module_name = 'sosa'"
		)->execute(array(true, 'SOSA_NAVIGATION_BAR'));
		Log::addConfigurationLog('sosa update navigation bar true');
		}
		// fin creation 
			
	}

}
