<?php
/*
 * webtrees: online genealogy
 * Copyright (C) 2016 webtrees development team
 * Copyright (C) 2016 JustCarmen
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
namespace Andre\WebtreesAddOn\Sosa\Template;

/*
*	V-1-0 for sosa V-2-7-9-4 25 JUL 2017 ADMIN
* 	site http://www.adumas.1s.fr/wt     http://adumas.shost.ca/    http://webtrees.adumas.shost.ca/
*
*/

use Fisharebest\Webtrees\Auth;
use Fisharebest\Webtrees\Controller\PageController;
//use Fisharebest\Webtrees\Controller\BaseController;
//use Fisharebest\Webtrees\Controller\AjaxController;
use Fisharebest\Webtrees\Filter;
use Fisharebest\Webtrees\Functions\FunctionsEdit;
use Fisharebest\Webtrees\I18N;
use Fisharebest\Webtrees\Site;
use Fisharebest\Webtrees\Individual;
use Fisharebest\Webtrees\File;
use Fisharebest\Webtrees\Tree;
use Fisharebest\Webtrees\Module;
use Fisharebest\Webtrees\Session;

use Fisharebest\Webtrees\Module\NP;
use Andre\WebtreesAddOn\Sosa\sosaModule;
use Andre\WebtreesAddOn\Sosa\sosaClass;

use Andre\WebtreesAddOn\Sosa\Template\PdfSosaTemplate;

use Andre\WebtreesAddOn\Sosa\myUpdateFunctions;

class AdminTemplate extends sosaModule {
private $ancestors1 = array();

	protected function pageContent() {
		$controller = new PageController;
		
		return
			$this->pageHeader($controller) .
			$this->pageBody($controller);
	}

	private function pageHeader(PageController $controller) {
		$fjs = WT_MODULES_DIR . $this->getName() . '/js/sosa.js';
		$msgFieldEmpty = I18N::translate('Fields with a * can not be empty !! ');
	
	
		$controller
			->restrictAccess(Auth::isAdmin())
			->setPageTitle($this->getTitle())
			->pageHeader()
			->addInlineJavascript('
							function include_css(css_file) {
								var html_doc = document.getElementsByTagName("head")[0];
								var css = document.createElement("link");
								css.setAttribute("rel", "stylesheet");
								css.setAttribute("type", "text/css");
								css.setAttribute("href", css_file);
								html_doc.appendChild(css);
							}
							include_css("' . WT_MODULES_DIR . $this->getName() . '/' . 'css/' . ''.'");
							
						')
			->addExternalJavascript(WT_AUTOCOMPLETE_JS_URL)
			->addInlineJavascript('autocomplete();')			
			->addInlineJavascript('var modName =\'' . $this->getName() .'\'
									var msgFieldEmpty = \'' .$msgFieldEmpty . '\' ')
			->addExternalJavascript($fjs);
						
	}
	
	/*
	////////////  Body //////////////////////
	*/
	private function pageBody(PageController $controller) {
		global $WT_TREE;

		

		/////////////////////
		// Admin page content
		/////////////////////
	
			
		if ((Filter::postBool('save'))&& Filter::checkCsrf() ) {
					$nav = $this->getSetting('SOSA_NAVIGATION_BAR');	
					$this->setSetting('SOSA_NAVIGATION_BAR', !$nav);							
		}	

		
		$html = $this->getBandeau($controller);
		$html .= '<br><div style="border:1px solid black;padding:10px;border-radius:4px;">
		   <form method="post" name="configform" action="' . $this->getConfigLink() . '">' .
				  Filter::getCsrf() .'
				<input type="hidden" id="save" name="save" value="' .true . '">
			<p><label>'.I18N::translate("Hide/Show the navigation bar for sosa (Default Show)?").'</label></p>
			<input type="submit" value="'.I18N::translate("Change").'">
		   </form>
		</div>';

		//$html choix de l'arbre....list
		/*
		*	param treeId
		*	param userId
		*	param  pid
		*/
		$html  .=  '<br><div style="border:1px solid black;
									padding:10px;
									border-radius:4px;
									background-color:lightgrey;
									">
					<p>
						<span><h4>' . 
							I18N::translate('You can create a de-cujus (root for sosa) for visitors, this table of sosas will be loaded only for visitors..., file for module Orphans will be created' )
						. '</h4></span>
					</p>
		<form method="post" name="selectvform" action="#" >' .
				  Filter::getCsrf() .'			
			<div id="top">
					<label for="NEW_SOSA_TREE" class="label">' . I18N::translate('Family tree') . '</label>
					<select name="NEW_SOSA_TREE" id="NEW_SOSA_TREE" class="tree" onChange="this.form.submit();">
					<option value="' .  $WT_TREE->getName(). '" selected="selected">' . I18N::translate('Choose an other tree') . '</option>';
		foreach (Tree::getAll() as $tree):
			if ($tree->getTreeId() == $WT_TREE->getTreeId()) {
				$html .= '<option value="' . $tree->getName() . '" data-ged="' . $tree->getName() . '" >' . $tree->getTitle() . '</option>';
			} else {
				$html .= '<option value="' . $tree->getName() . '" data-ged="' . $tree->getName() . '">' . $tree->getTitle() . '</option>';
			}
		endforeach;
		$html .= '	</select>
					</div></form>';
					
	$html .= '<br>';	
	$html .=  '<table><tr><td valign="middle">
			<b>' . I18N::translate('') . '</b>';
		$indiname = '';		
	$t = I18N::translate('Write a name or a ref which must start with a ' . $this->getSetting('GEDCOM_ID_PREFIX') . ' I520 ... ');
	
	$Tree = Filter::post('NEW_SOSA_TREE','',$WT_TREE->getName());
	
	$html .= 	'</td>
				<td width="50px">&nbsp;</td>
				<td>	
				<table class="list_table">
			<tr>
			<td class = "descriptionbox">
			<div title = "' . $t . I18N::translate(', system will find it out if exists') .'">';
	$html .= I18N::translate('  <b>de cujus for this tree:   </b>'). $Tree . '</div>' . '</td>';
	$rootid = '';
	$xref = '';		
	
	
	$html .= 	'</td>
				<td><div class="col-sm-9">
				<form method="post" name="configform" action="' . $this->confSosaVisitor() . '">
					<input data-autocomplete-type="INDI"
							data-autocomplete-ged="' . $Tree .'" 
									type="text"   name="xref" id="xref" size="10" value="';
					 	echo $xref; 													
	$html .= '"/></div>';				
	$html .= 	'</td>
				<td rowspan="2" class="facts_label03">
					<input type="hidden" name="NEW_SOSA_TREE" value="' . $Tree . '":>
					<input id="dcadminok" type="submit" name="sosaOK" value="' . I18N::translate('OK') . '">
				</td>
				</tr></table>			
			</td></tr>
			';
/*			if (!null == Module::getModuleByName('orphans') ){
					$label = I18N::translate('Update file orhans?');
					$title = I18N::translate('It can need a long time for large genealogies...');
						$html .= '<tr><td colspan="2"><i>
							<label>' . $label . '</label>' . '  ' . '<input type="checkbox" id="uodateorphans" ' . $title .'>
							</i></td></tr>
						';
				}
*/			
			$html  .= '</table>' . 
						'</form>' .
						'</div>';
						
			
	return $html;	
	}
	
/////////////////// Header ///////////////////

	private function getBandeau($controller){
		$linkdoc = Site::getPreference('MY_VERSIONS_DOC_BASE_URL') . $this->getName() . '.html';
		$linklog = Site::getPreference('MY_VERSIONS_DOC_BASE_URL') . $this->getName() . '_log.txt';
		$linkupd = 'module.php?mod=' . $this->getName() . '&mod_action=check_version';
		
 		//update version?
		myUpdateFunctions::checkNewModsVersions();
		$spref = Site::getPreference('LATEST_MY_MODS_VERSION');
		
		if ($spref !== null){
			$new_version = unserialize($spref)[$this->getName()]['version'];
		} else {		
			$new_version = self::CUSTOM_VERSION;
		}

		$html = '<ol class="breadcrumb small">
			<li><a href="admin.php">'. I18N::translate('Control panel') . '</a></li>
			<li><a href="admin_modules.php">' . I18N::translate('Module administration') . '</a></li>
			<li class="active">' . $controller->getPageTitle() . '</li>
		</ol>';
		$html .= '<div style="
						border:2px solid black;
						border-radius:3px;
						padding:10px;">';
					
		$html .= '	<table style="width:95%;">
			<tr>
			<td style="width:65%; text-align:center;">
			<h3>' . $this->getTitle() . '  V-' . self::CUSTOM_VERSION . '   ' . '<span style="font-size:60%;">(' . 
							self::CUSTOM_VERSION_DATE . ')</span></h3>
			</td>
			<td style="text-align:center;"><span>
				<a href="' . $linkdoc . '">' .  I18N::translate('Documentation') . '
				</a></span></td>
			<td style="text-align:center;"><span>
			<a href="' . $linklog . '">' .  I18N::translate('Change.log') . '
			</a></span></td>
			<td style="text-align:center;" >
			<a href="' . $linkupd . '" title="' . I18N::translate('Checking is done every week, but you can force it now')  . '"><button 
												style="background-color:lightgrey;"
												>' . I18N::translate('Check new version now!') . '</button></a>
			</td>
			</tr>';
			
		$html .= '<tr><td style="text-align:center;" colspan="3">';
		//new version?
		$html .= myUpdateFunctions::lookForNewVersion($this->getName(), self::CUSTOM_VERSION, $new_version ) ;
		$html .= '</td></tr>';
		
		$html .= '</table></div><br>';

	return $html;
	}
	
	public function forceUpdate(){
		myUpdateFunctions::checkNewModsVersions($now = true);
		header('Location:module.php?mod=' . $this->getName() .'&mod_action=admin_config');
	}	
}
