<?php
/**
 * webtrees: online genealogy
 * Copyright (C) 2015 webtrees development team
 * Copyright (C) 2015 JustCarmen
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *---------------------------------------------------------------------
 *   V 1.0.1 for "My orphans" V-1-7-9-1for Webtrees 1.7.9
*   André DUMAS June 2017
*   http://www.adumas.1s.fr/wt
 */
namespace Andre\WebtreesAddOn\Sosa\Template;


use Fisharebest\Webtrees\File;
use Fisharebest\Webtrees\Filter;
use Fisharebest\Webtrees\I18N;


use Andre\WebtreesAddOn\Sosa\sosaModule;
use Andre\WebtreesAddOn\Sosa\Template\MYPDF;

use TCPDF;


class PdfSosaTemplate extends TCPDF {
	
	const PdfTemplate_CUSTOM_VERSION  = '1-0-1 2018-03-05 AD';
		
	public function pageBody($format, $file = '', $dir ='') {				
		global $WT_TREE;
		
				$titre = I18N::translate('Sosa: lists');	

				$tmp_dir = WT_DATA_DIR . 'tmp-' . $WT_TREE->getName() . '/';
				$tmp_file = 'sosa.html';
					
				$file = $tmp_dir . $tmp_file;  
				$html = file_get_contents($file);
				$html =  str_replace('&nbsp', ' ', $html) ;
				
// ---------------------------------------------------------
$format = 'A4';
$PDF_PAGE_FORMAT = $format; 
$PDF_UNIT = 'mm';
$PDF_PAGE_ORIENTATION = 'P'; //L pour paysage

// create new PDF document
$pdf = new MYPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);

// set document information
$pdf->SetCreator(PDF_CREATOR);
$pdf->SetAuthor('André DUMAS');
$pdf->SetTitle('Listes sosa');
$pdf->SetSubject('Sosa ');
$pdf->SetKeywords('TCPDF, PDF, sosa, listes, Webtrees');

// set default header data
//$pdf->SetHeaderData('', '', 'List Sosa', PDF_HEADER_STRING);

// set header and footer fonts
$pdf->setHeaderFont(Array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
$pdf->setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));

// set default monospaced font
$pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);

// set margins
$pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
$pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
$pdf->SetFooterMargin(PDF_MARGIN_FOOTER);

// set auto page breaks
$pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);

// set image scale factor
$pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);

// ---------------------------------------------------------

// set font
$pdf->SetFont('dejavusans', '', 9);

// add a page
$pdf->AddPage();


// output the HTML content
		$pdf->writeHTML($html, true, false, true, false, '');
		$pdf->Output($tmp_dir . 'sosa_list.pdf', 'FD') ;
		
return true;				
}

	public function test(){
		return 'retour ok';
	}
}
	
