<?php
namespace Andre\WebtreesAddOn\Sosa;
/* =================================
*   class sosaClass V-1-0 for module sosa V-2-7-1 for WT 1.7.1 and +
*   André DUMAS http://www.adumas.1s.fr/wt
*   July 2015
*	---------------------------------------
*	Version 1-0-1 for module Sosa v-2-7-2-1-01
*	compatibility with module orphans
*	delete files orphans_?.html from /data
*	when ##sosa is updated and/or de-cujus changed
*	 André DUMAS FRANCE DEC 2015
*---------------------------------
*	Version 1-0-2 for module sosa V-2-7-4-1
*	Some changes on popups and add DB Shema 
*	André MAY 2016
*
 *	Version 1-0-3 for module sosa V-2-7-4-1
 *   for WT 1.7.4-1
 *  add a navigation bar for sosa only
 *  Andre DUMAS 30-04-2016 FRANCE
 *	Version 1-0-4 for sosa 2-7-9-1
 *		AD 25-05-2017  AD  F
 ************
 *	V-1-0-5  todo include version for visitor
 *  =.=.=.=.=.=.=.=.=.=.=.=.=.=.=.=.=.=.=.=
 *  =	André DUMAS FRANCE				  =
 *  = http://www.adumas.1s.fr/wt/		  =
 *  =  http://www.adumas.1s.fr/download/  =
 *  = contact: a.dumas1  at  free.fr	  =
 *  =.=.=.=.=.=.=.=.=.=.=.=.=.=.=.=.=.=.=.=
*/

use Fisharebest\Webtrees\Controller\PageController;
use Fisharebest\Webtrees\Database;
use Fisharebest\Webtrees\Filter;
use Fisharebest\Webtrees\Functions\Functions;
use Fisharebest\Webtrees\Functions\FunctionsPrint;
use Fisharebest\Webtrees\GedcomRecord;
use Fisharebest\Webtrees\Tree;
use Fisharebest\Webtrees\File;
use Fisharebest\Webtrees\I18N;
use Fisharebest\Webtrees\Auth;
use Fisharebest\Webtrees\Individual;
use Fisharebest\Webtrees\Module;


use PDO;

class sosaClass extends sosaModule {

	public static $sosaNav;
	public static  $ancestors1 = array();
	
// = = = = = = = = = = = = = = = =
	/*
	*  $user_id = 0 for visitor
	*/
private function find_sosa($personid, $ged_id, $uid = null){
	if ($uid === 0){$user_id = 0;}
	if ($uid === null){
		$user_id = self::getAuthId();
	}
	
	$statement = null;
	if (is_null($statement)) {
		$statement = Database::prepare("SELECT SQL_CACHE sosa_num, sosa_gen FROM `##sosa` WHERE sosa_xref=? AND sosa_gid=? AND sosa_user=?");
		return $statement->execute(array(
			$personid,
			$ged_id,
			$user_id
		))->fetchAll();
	}
}

// = = = = = = = = = = = = = = = =
protected function find_rootid($ged_id){
	$user_id = self::getAuthId();
	$rootid = Database::prepare("SELECT SQL_CACHE sosa_xref from `##sosa` WHERE sosa_num = 1 AND sosa_gid = ? AND sosa_user=?")
		->execute(array(
		$ged_id,
		$user_id
	))->fetchOne();
	return $rootid;
}

	/*
	*   search if sosa exists
	*/
	protected function getSosaXref($sosa){
		global $WT_TREE;
	$user_id = self::getAuthId();
	$sosaXref = Database::prepare("SELECT SQL_CACHE sosa_xref from `##sosa` WHERE sosa_num = ? AND sosa_gid = ? AND sosa_user=?")
		->execute(array(
					$sosa,
					$WT_TREE->getTreeId(),
					$user_id
				))->fetchOne();
	return $sosaXref;
}

public static function readRootFromTable($ged_id){
	$user_id = self::getAuthId();
	$rootid = Database::prepare("SELECT SQL_CACHE sosa_xref from `##sosa` WHERE sosa_num = 1 AND sosa_gid = ? AND sosa_user=?")
		->execute(array(
		$ged_id,
		$user_id
	))->fetchOne();
	return $rootid;
}
// = = = = = = = = = = = = = = = =

//======================================
   /* $pid xref de la personne courante
   /* $ged_id  indice du gedcom courant
   /*
   */
   
	protected function titre($pid, $ged_id) {		
		global $WT_TREE;
	// Faire en sorte que le titre commence toujours par Sosa (y compris dans la traduction)
	// afin que le module apparaisse à sa place dans le menu Administration
	$sosa = array(); // tableau contenant le numéro sosa de la personne et la generation correspondante
	
		if (Auth::id() === null){$uid = 0;} else {$uid = null;}			   			   
		$sosa = $this->find_sosa($pid,$ged_id, $uid);
			if (!($sosa == null)) {
				$title = ":  ".$sosa[0]->sosa_num."   Gen:  ".$sosa[0]->sosa_gen."";
			} else {
				$title = I18N::translate(' : none');
		    }		
	return $title;	
	}
	
	/*
	*  read table #sosa for $WT_TREE and this user
	*/
protected function readSosaTable(){
	global $WT_TREE;
	$user_id = self::getAuthId();
	$rq = Database::prepare("SELECT SQL_CACHE * from ##sosa WHERE sosa_gid = ? AND sosa_user=?")
		->execute(array(
		$WT_TREE->getTreeId(),
		$user_id
	))->fetchAll();
	return $rq;
}


	/* 
	*	Navigation sosa
	*   Father Mother wife/husband child
	*/
	protected static function navSosa($sosa_num){
		global $WT_TREE;
		$navIds = array();
		
		$father = $sosa_num*2;
		$mother = $father + 1;
		$child = (int)($sosa_num/2);
		if ($sosa_num%2 == 0){
			$sp = $sosa_num + 1;
			$husband = '';
		} else {
			$sp = $sosa_num - 1;
			$wife = '';
		}
		$user_id = self::getAuthId();
		$sosa = Database::prepare("SELECT SQL_CACHE sosa_xref, sosa_num from ##sosa 
						WHERE sosa_gid = ? AND sosa_user = ?
						AND sosa_num IN (?, ?, ?, ?) 
						ORDER BY sosa_num")
		->execute(array(
						$WT_TREE->getTreeId(),
						$user_id,
						$child,
						$mother,
						$father,
						$sp
						))->fetchAll();
		foreach($sosa as $navid){
			$navIds[$navid->sosa_num] = $navid->sosa_xref;
		}				
					
		return json_encode($navIds);				
	}
	/*-------------------------------------------------------------
	*    Compatibility with Module Orphans working with Sosa   André DUMAS DEC 2015
	*--------------------------------------------------------------
	*  Find orphans (fatherless and/or motherless )
	*  in the table #sosa
	*  global $WT_TREE
	*   return array with orphans (sosa, xref)
	*/

	

	//=====================Orphans========================================
	
	/*
	* 	Pour compatibilité avec Module Orphans
	*	après chaque update de la table ##sosa
	* 	on efface les fichier orphans du répertoire /data
	*   Ils seront recréés à la prochaine connexion d'un manager
	*
	*/
	
	private static function deleteOrphans(Tree $tree = null, $user_id = null) {
		global $WT_TREE;
		if (null == $tree){		
			$tree = $WT_TREE;
		}
		$tree_id = $tree->getTreeId();
		
		/*if ( Module::getModuleByName('orphans') ){
			$o = new orphansModule();
		}*/
	//get files params	
	$subdir = Database::prepare("
		SELECT SQL_CACHE setting_value FROM ##module_setting WHERE setting_name =  ? AND module_name = ?
	")->execute(array(
						'ORPHANS_CACHE_DIR',
						'orphans'))->fetchOne();	
		
		$user_id = self::getAuthId();
		$filename = WT_DATA_DIR . $subdir .'/orphans_'. $user_id . '_' .$tree_id.'.html';
		
		if (file_exists($filename)) {
		File::delete($filename);
		}
	return true;	
	}	
	


/*
*    NEW SOSA
*/

	/*---------------------------------------------
	*		SOSA table
	*----------------------------------------------
	*/
	
		/*
	*
	*	return array('father' , 'mother')
	*/
	protected static function getParents(Individual $person){
		//global $WT_TREE;
		$parents = array();
				
		/* parents  */
		if ($person->getPrimaryChildFamily()) {
			$parentFamily = $person->getPrimaryChildFamily();
				$parents['father'] = $parentFamily->getHusband();
				$parents['mother'] = $parentFamily->getWife();
		} else {
				$parents['father'] =  null;
				$parents['mother'] = null;
		}
	return 	$parents;
	}

	
	
	private static function fillTableOfSosa($values){
		$sql = "INSERT INTO `##sosa` (sosa_xref, sosa_gid, sosa_num, sosa_gen, sosa_user) VALUES " . $values ;
		try {
		$c = Database::exec($sql); 
		}
		catch(PDOException $ex) {
			// already exists?
		}
	return true;	
	}
	
	/*
	*
	*	param $user_id  not null only to set visitor's sosas
	*	 return string data to import in table sosa
	*/	
	
		public static function getSosaTableValues($pid, $tree_id, $user_id,  $ancetres){
		global $WT_TREE;
		
		/* 
		*	(sosa_xref, sosa_gid, sosa_num, sosa_gen)..
		*	(val1, val2..), (val1, val2,..), ...
		*/
		
		//root		
		$values = ''; 
		
		foreach  ( $ancetres as $sosa => $id ){
			$values .= "('" . $id ."','" . $tree_id . "','" . $sosa . "','" . self::getSosaGeneration($sosa) . "','" . $user_id . "'),";
		}
		//last ','
	return substr($values, 0,  - 1);	
	}

	/*
	*	Choose a dejus
	*/
		protected function chooseNewDeCujus(){
		global $WT_TREE, $pid, $controller;
		
		$html = '<div class="helpheader"><h2>' . I18N::translate('Choose a new “de&nbsp;cujus”') . '</h2></div>';
		
		$controller
					->restrictAccess(Auth::check() )
					->addExternalJavascript(WT_AUTOCOMPLETE_JS_URL)
					->addInlineJavascript('autocomplete();')					
					->addInlineJavascript('
							var modName = \''.$this->getName().'\';							
							');	
							
	$html .=  '<table><tr><td valign="middle">
			<b>' . I18N::translate('') . '</b>';
		$indiname = '';			
	$html .= 	'</td>
				<td width="50px">&nbsp;</td>
	<td>				
		<table class="list_table">
			<tr>
			<td class = "descriptionbox">
			<div title = ' . I18N::translate('Enter a first name, name or XREF (Ixxx), system will find it out') . '">';
	$html .= I18N::translate('  <b>de cujus..:   </b>') . '</div>' . '</td>';
	$rootid = '';
	$xref = '';			
	$html .= 	'
				<td><div class="col-sm-9">
					<input data-autocomplete-type="INDI" type="text"   name="xref" id="xref" size="10" value="';
					 	echo $xref; 													
	$html .= '"/></div>';				
	$html .= 	'</td>
				<td rowspan="2" class="facts_label03">
					<input type="submit" id="sosaOK" value="' . I18N::translate('OK') . '">
				</td>
				</tr></table>			
			</td></tr>
			<br>
			';
			
			
			$html  .= '</table>';
	return $html;	
	}

 

	public static function getSosaGeneration($sosa) {
		$generation = (int) log($sosa, 2) + 1;

		//return '<sup title="' . I18N::translate('Generation') . '">' . $generation . '</sup>';
		return $generation;
	}
	
	
	protected static function updateTableOfSosa($pid, $tree_id = null, $user_id, $ancetres){
		global $WT_TREE;
				
		// get values

		$values = ''; 		
		foreach  ( $ancetres as $sosa => $id ){
			$values .= "('" . $id ."','" . $tree_id . "','" . $sosa . "','" . self::getSosaGeneration($sosa) . "','" . $user_id . "'),";
		}
		//last ','
		
	$values = substr($values, 0,  - 1);
		
	// delete sosa AND //fillTable
			self::deleteTableSosa($tree_id, $user_id);
		
		if ( strlen($values) > 0 ){
			self::fillTableOfSosa($values);	
			if (Auth::Id() > 0){ //not visitor
				//Cohérence avec WT
				$WT_TREE->setPreference('PEDIGREE_ROOT_ID', $pid);//gedcom_setting
				$setting_name = 'gedcomid'; // gedcom preferences -> ind par defaut
				//rootid  -> user_gedcom_setting  id auquel est lié l'utilisateur
				$setting_value = $pid;
				$WT_TREE->setUserPreference(Auth::user(), $setting_name, $setting_value);				
			}	
			// file data/orphans_? deleted, it will created again automaticly
			self::deleteOrphans($tree = null, $user_id);
		}	
	return true;	
	}
	
	/*
	*  Delete data for this tree
	*/
	protected static function deleteTableSosa($ged_id, $user_id){

	Database::prepare("DELETE FROM ##sosa WHERE sosa_gid = ? AND sosa_user = ?")->execute(array(
		$ged_id,
		$user_id
	));
	return true;
}

	/*
	*	user Preference for this Tree
	*
	*/
	protected function setUserPreference(){
		//$WT_TREE->getUserPreference(Auth::user(), 'gedcomid')
		/*   setUserPreference(User $user, $setting_name, $setting_value)
			Change id  reference for this user's gedcom
		*/
		
	}
	


	
	public static function readSosaTableNew($treeid, $uid){
	
	$rq = Database::prepare("SELECT SQL_CACHE * from ##sosa WHERE sosa_gid = ? AND sosa_user = ? ORDER BY sosa_num")
		->execute(array(
		$treeid,
		$uid
	))->fetchAll();
	return $rq;
	}


	// get IP visitor
	   
    /**
     * Récupérer la véritable adresse IP d'un visiteur
	 *    TODO   active for visitors...
     */
    protected static function getVisitorAddr() {
    	// IP si internet partagé
    	if (isset($_SERVER['HTTP_CLIENT_IP'])) {
    		return $_SERVER['HTTP_CLIENT_IP'];
    	}
    	// IP derrière un proxy
    	elseif (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) {
    		return $_SERVER['HTTP_X_FORWARDED_FOR'];
    	}
    	// Sinon : IP normale
    	else {
    		return (isset($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : '');
    	}
    }
    

	
		/* add user : visitor
	*   visitor -> id = 0
	*/
	public static function getAuthId(){
		if (( $user_id  = Auth::id()) === null){
			$user_id = 0;
		} 
	return $user_id;	
	}
	
		/**   TODO ??
	 * Create a new user: visitor -> user_id = 10000 ???
	 *
	 * The calling code needs to check for duplicates identifiers before calling
	 * this function.
	 *
	 * @param string $user_name
	 * @param string $real_name
	 * @param string $email
	 * @param string $password
	 *
	 * @return User
	 */
	public static function createVisitor() {
		$user_name = 'visitor'; $real_name = 'visitor'; $email = ''; $password = '';
		Database::prepare(
			"INSERT INTO `##user` (user_id, user_name, real_name, email, password) VALUES (:user_id, :user_name, :real_name, :email, :password)"
		)->execute(array(
			'user_id'  => 0,
			'user_name' => $user_name,
			'real_name' => $real_name,
			'email'     => $email,
			'password'  => self::passwordHash($password),
		));

		// Set default blocks for this user
		$user = self::findByIdentifier($user_name);
	/*	Database::prepare(
			"INSERT INTO `##block` (`user_id`, `location`, `block_order`, `module_name`)" .
			" SELECT :user_id , `location`, `block_order`, `module_name` FROM `##block` WHERE `user_id` = -1"
		)->execute(array('user_id' => $user->getUserId()));
	*/
		return $user;
	}

	
	/**
	 * Load the ancestors of an individual, so we can highlight them in the list
	 *
	 * @param Individual $ancestor
	 * @param int        $sosa
	 */
	public function loadAncestors(Individual $ancestor, $sosa) {
		if ($ancestor) {
			self::$ancestors1[$sosa] = $ancestor->getXref();
			foreach ($ancestor->getChildFamilies() as $family) {
				foreach ($family->getSpouses() as $parent) {
					$this->loadAncestors($parent, $sosa * 2 + ($parent->getSex() == 'F' ? 1 : 0));
				}
			}
		}
	}	
}