<?php
/*
 * webtrees: online genealogy
 * Copyright (C) 2016 webtrees development team
 * Copyright (C) 2016 JustCarmen
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
namespace Andre\WebtreesAddOn\Sosa;

/*
*	V-1-0 for sosa V-2-7-9-7 25 MAR 2018 ADMIN
* 	site http://www.adumas.1s.fr/wt     http://adumas.shost.ca/    http://webtrees.adumas.shost.ca/
*
*/

use Fisharebest\Webtrees\Auth;
use Fisharebest\Webtrees\Controller\PageController;
//use Fisharebest\Webtrees\Controller\BaseController;
//use Fisharebest\Webtrees\Controller\AjaxController;
use Fisharebest\Webtrees\Filter;
use Fisharebest\Webtrees\Functions\FunctionsEdit;
use Fisharebest\Webtrees\I18N;
use Fisharebest\Webtrees\Site;
use Fisharebest\Webtrees\Individual;
use Fisharebest\Webtrees\File;
use Fisharebest\Webtrees\Tree;
use Fisharebest\Webtrees\Module;
use Fisharebest\Webtrees\Session;

use Andre\WebtreesAddOn\Sosa\myUpdateFunctions;


class sosaLists extends sosaModule {
	
	///////////////////   Pdf outputs  //////////////////
//
//	wjth large genealogy we choose to get a page for each grand parent of de-cujus
//
	/*	grand parents tables
	*	de-cujus = 1 SFather = 2, Smother = 3
	*	read sosas and sort
	*	$grandParents = array( 'gpFF' 	=> array(),
	*							'gpFM' 	=> array(),
	*							'gpMF' 	=> array(),
	*							'gpMM' 	=> array()
	*						)
	*
	*/
	protected function displaySosaList($print = false){
			$asc = $this->getGrandParents();		 
			Session::put('asc', $asc);
			$html = $this->setHtmlSosaPage($asc);
			$html .= '<p class="lprint" title="' . I18N::translate('Click and wait please with a large genealogy') . '">		
					<button  class="lptxt" style="width:45%;">' . I18N::translate('Export TXT file'). '</button>
					<button class="lppdf">' . I18N::translate('Export PDF file'). '</button>
					</p>';
			$html .= '<div class="corpus" >
				  <ul>
						<li><a href="#gff">' . I18N::translate('Paternal grandfather') . '</a></li>
						<li><a href="#gmf">' . I18N::translate('Paternal grandmother') . '</a></li>
						<li><a href="#gfm">' . I18N::translate('Maternal grandfather') . '</a></li>
						<li><a href="#gmm">' . I18N::translate('Maternal grandmother') . '</a></li>
						<li><a href="#ge">' . I18N::translate('General: all') . '</a></li>
					</ul>';
			$h4 = $this->setSosaPages($asc, 4);
			$h5 = $this->setSosaPages($asc, 5);
			$h6 = $this->setSosaPages($asc, 6);
			$h7 = $this->setSosaPages($asc, 7);
			
			$hg = $this->setSosaPages($this->getArrayAllSosa($asc['id']), 1);
			
			$html .= '<div id="gff">' . $h4 . '</div>' ;
			$html .= '<div id="gmf">' . $h5 . '</div>';			
			$html .= '<div id="gfm">' . $h6 . '</div>';
			$html .= '<div id="gmm">' . $h7 . '</div>';
			$html .= '<div id="ge">' . $hg . '</div>';
			
			
			$html .= '</div>'; //corpus
			$html .= $this->getHtmlSosaFooter();
			
		return $html;
	} 


	/*
*	Array with all sosa (this tree, this user)
*	for list of sosa ->class sosaLists
*/
public function getArrayAllSosa($pid){
	global $WT_TREE;
	$person = Individual::getInstance($pid, $WT_TREE);				
		$this->module()->loadAncestors($person, 1);
	$asc =  sosaClass::$ancestors1; 
	ksort($asc);
	sosaClass::$ancestors1 = array();						
	return $asc;
}
	

	protected  function getTextFile($asc, $s){
		global $WT_TREE;
	

		//What list?
		switch ($s) {
			case '4':
				$ascs = $asc['gpFF'];
			break;
			case '5':
				$ascs = $asc['gpMF'];
			break;
			case '6':
				$ascs = $asc['gpFM'];
			break;
			case '7':
				$ascs = $asc['gpMM'];
			break;
			case '8':
				$ascs = $this->getArrayAllSosa($asc['id']);
			break;
		}
		
	//tmp dir & file
	$tmp_dir = WT_DATA_DIR . 'tmp-' . $WT_TREE->getName() . '-' . date('YmdHis') . '/';
	$tmp_dir = WT_DATA_DIR . 'tmp-' . $WT_TREE->getName() . '/';
		$tmp_file = 'sosa.txt';
		
		if (!File::mkdir($tmp_dir)) {
			echo "Error : Could not create temporary path!";
			return;
		}

		$file = $tmp_dir . $tmp_file;
		$handle = fopen($file, 'w+');	


	///////////////
	$person = Individual::getInstance($asc['id'], $WT_TREE);
	$personf = Individual::getInstance($asc['idf'], $WT_TREE);
	$personm = Individual::getInstance($asc['idm'], $WT_TREE);
		
		$txt = PHP_EOL;
		$txt .= '=====================================================================================================================' . PHP_EOL;
		$txt .= 'Module Sosa ' . self::CUSTOM_VERSION . ' MAR 2018  André DUMAS FRANCE http://www.adumas.1s.fr' . PHP_EOL;
		$txt .= '=====================================================================================================================' . PHP_EOL;
		$txt .=  "\t\t\t" . I18N::translate('List of sosa') . PHP_EOL;
		$txt .= strip_tags($person->getFullName()) . "\t" . $this->getLifespan($person)  . PHP_EOL;
		
		$txt .= '=====================================================================================================================' . PHP_EOL;
		$txt .= PHP_EOL;
			
		$txt .=   "\t\t\t\t\t" . I18N::translate('Parents');
		$txt .= PHP_EOL;
			
		$txt .= 'Gen: ' . '2' . '  sosa = ' . '2' . "\t" . strip_tags($personf->getFullName()) . "\t" . $this->getLifespan($personf)  ."\t\t" .'x' . "\t" 
				 . '  sosa = ' . '3' . "\t" . strip_tags($personm->getFullName()) . "\t" . $this->getLifespan($personm)  . PHP_EOL;
		$txt .= '=====================================================================================================================' . PHP_EOL;
		$txt .= PHP_EOL;
		
		
		

	if (!null == $ascs){
		foreach ($ascs as $sosa => $pid){
			$person = Individual::getInstance($pid, $WT_TREE);
			$gen = sosaClass::getSosaGeneration($sosa);
			if ($person){
				$txt .= "\t\t" . 'Gen: ' . $gen . '  sosa = ' . $sosa . "\t" . strip_tags($person->getFullName()) . "\t" . $this->getLifespan($person) . "\t" . '  °:  ' . $person->getBirthPlace() . PHP_EOL; 
			}
			if (strlen($txt) > 65500){
				fwrite($handle, $txt);
				$txt = '';
			}	
		}
	}
		$txt .= PHP_EOL;
		
		fwrite($handle, $txt);
		fclose($handle);
		$txt = '';
		
	return true;		
	}
	

	/*
		g = 1 s =4 	pw(2,0)
		g = 2 s = 8  9  	pw(2,1)	
		g = 3 s = 16 17 18 19	pw 2,2
	*/
	

	private function getSosaItem($person, $sosa){
		$gen = sosaClass::getSosaGeneration($sosa);
		if (!null === $person){
		$html = '<li><b><i>Gen: ' . $gen . ' Sosa = ' . $sosa .' : </i></b>
			 <a href="' . $person->getHtmlUrl() . '" title="sosa = ' . $sosa . '"><i class="">' . $person->getFullName() . '</i>- &nbsp ' . 
			 $lf . '</a>' .
			 '</li>';
		} else {
			$html = '<li><b><i>Gen: ' . $gen . ' Sosa = ' . $sosa .' : </i></b>
			  &nbsp ' . 
			 ' ? ' . '</a>' .
			 ' &nbsp ° ' . ' ? ' .
			'</li>';
		}
			
	return $html;		
	}
			
		private  function getGrandParents(){
			global $WT_TREE;
			$root = sosaClass::readRootFromTable($WT_TREE->getTreeId());
			$person = Individual::getInstance($root, $WT_TREE);
			//$ancestors = sosaModule::getMyAncestors($person, 1); 
			$this->module()->loadAncestors($person, 1);
			$ancestors = sosaClass::$ancestors1;
			ksort($ancestors);
			$id = $ancestors[1];
			sosaClass::$ancestors1 = array();
			
			$idf = null;
			$idm = null;
	if (array_key_exists('2', $ancestors)){	
		$idf = $ancestors[2];
		if (array_key_exists('4', $ancestors)){	
			//F GP  4
				//father : asc grand  father
				$person = Individual::getInstance($ancestors[4], $WT_TREE);			
					
					$gff = $this->module()->loadAncestors($person, 4);
					$gff = sosaClass::$ancestors1;					
					ksort($gff);					
					sosaClass::$ancestors1 = array();					
		} else {
			$gff = null;
		}
		
			
		if (array_key_exists('5', $ancestors)){	
			//F GM  5
				//father : asc grand  father
				$person = Individual::getInstance($ancestors[5], $WT_TREE);				
					//$gmf = sosaModule::getMyAncestors($person, 5);
					$this->module()->loadAncestors($person, 5); 
					$gmf = sosaClass::$ancestors1;
					ksort($gmf);
					sosaClass::$ancestors1 = array();		
		} else {
			$gmf = null;
		}
	} else {
		$gff = null;
		$gmf = null;
	}
	
	if (array_key_exists('3', $ancestors)){	
		$idm = $ancestors[3];
		if (array_key_exists('6', $ancestors)){
			//M GP  6
				//father : asc grand  father
				$person = Individual::getInstance($ancestors[6], $WT_TREE);				
					//$gfm = sosaModule::getMyAncestors($person, 6);
					$this->module()->loadAncestors($person, 6); 
					$gfm = sosaClass::$ancestors1;
					ksort($gfm);
					sosaClass::$ancestors1 = array();					
		} else {
			$gfm = null;
		}
		
		if (array_key_exists('7', $ancestors)){
			//M GM  7
				//father : asc grand  father
				$person = Individual::getInstance($ancestors[7], $WT_TREE);				
					//$gmm = sosaModule::getMyAncestors($person, 7);
					$this->module()->loadAncestors($person, 7); 
					$gmm = sosaClass::$ancestors1;
					ksort($gmm);
					 sosaClass::$ancestors1 = array();			
		} else {
			$gmm = null;
		}
	} else {
		$gfm = null;
		$gmm = null;
	}	

	$grandParents = array( 	'id'  => $id,
							'idf' => $idf,
							'idm' => $idm,
							'gpFF' => $gff,
							'gpMF' => $gmf,
							'gpFM' => $gfm,
							'gpMM' => $gmm
						);	
	return $grandParents;	
	}
	
	protected function setHtmlSosaPage(array $asc){
		global $WT_TREE, $conyroller;
		$js = 	'';

		$jq = '	';
		
		
		$css = WT_MODULES_DIR.$this->getName().'/'.'css/lsosa.css';
		$csswait = WT_MODULES_DIR.$this->getName().'/'.'css/wait.css';
		
		
		$jswait = WT_MODULES_DIR.$this->getName().'/'.'js/wait.js';
		
		$controller = new PageController;
		$controller->pageHeader(true)
					->restrictAccess(Auth::check() ) 
					->setPageTitle('Export sosa')
					->restrictAccess(Auth::check() )
					->addExternalJavascript(WT_AUTOCOMPLETE_JS_URL)
					->addInlineJavascript('autocomplete();')
					->addInlineJavascript($js)
					->addInlineJavascript('
							var modName = \''.$this->getName().'\';
							var msgGFF = \'' . I18N::translate('Paternal grandfather') . '\';
							var msgGMF = \'' . I18N::translate('Paternal grandmother') . '\';
							var msgGFM = \'' . I18N::translate('Maternal grandfather') . '\';
							var msgGMM = \'' . I18N::translate('Maternal grandmother') . '\';
							var msgGE = \'' . I18N::translate('All') . '\';
							$("div.corpus").tabs();
							$("body").css("background-color", "#D8D8D8");
							')
					->addInlineJavascript('
								var newSheet=document.createElement("link");
								newSheet.setAttribute("href","' . $css . '");
								newSheet.setAttribute("type","text/css");
								newSheet.setAttribute("rel","stylesheet");
								newSheet.setAttribute("media","all");
								document.getElementsByTagName("head")[0].appendChild(newSheet);
						')
					->addInlineJavascript('
								var newSheet=document.createElement("link");
								newSheet.setAttribute("href","' . $csswait . '");
								newSheet.setAttribute("type","text/css");
								newSheet.setAttribute("rel","stylesheet");
								newSheet.setAttribute("media","all");
								document.getElementsByTagName("head")[0].appendChild(newSheet);
						')
						->addInlineJavascript($jq)
						->addExternalJavascript($jswait)
						;	
													
		$bgc = 'lightgrey';
				
		$person1 = Individual::getInstance($asc['id'], $WT_TREE);
						
		if ( $asc['idf'] != null){
			$person2 = Individual::getInstance($asc['idf'], $WT_TREE);
		} else {
			$person2 = null;
		}
		
		if ( $asc['idm'] != null){
			$person3 = Individual::getInstance($asc['idm'], $WT_TREE);
		} else {
			$person3 = null;
		}
		
		
		$html = '';
				
		$bgc = $person1->getSex() == 'M' ? 'lightgrey' : 'lightpink';
		$html .= ' <div class="htable">
					<table><tr><td colspan="4" class="l0">';
		$html .= '<div id="id0" style="background-color:' . $bgc .';">
					<span>
					Sosa : ' . ' 1 ' . 'Gen= ' . ' 1 ' .
							'<a class="" href="' . $person1->getHtmlUrl() . '">' . strip_tags($person1->getFullName() ) . 
							'</a> (' . $person1->getLifeSpan() . 
					')</span>
				</div>
				</td></tr>
				<tr>
				<td class="l1" colspan="2">';
				if ($person2){				
				  $bgc = $person2->getSex() == 'M' ? 'lightgrey' : 'lightpink'; 
		$html .=	'<div id="id1" style="background-color:' . $bgc .';">
					<span>
					Sosa : ' . ' 2 ' . 'Gen= ' . ' 2 ' .
							'<a class="" href="' . $person2->getHtmlUrl() . '">' . strip_tags($person2->getFullName()) . 
							'</a> (' . $person2->getLifeSpan() . 
					')</span>
				</div>';
				} else {
					$bgc = 'white';
		$html .=	'<div id="id1" style="background-color:' . $bgc .';">
					<span>
					Sosa : ' . ' 2 ' . 'Gen= ' . ' 2 ' .
					'</span>
				</div>';	
				}
				
		$html .=	'</td>
		<td class="l1" colspan="2">';
				if ($person3){
				  $bgc = $person3->getSex() == 'M' ? 'lightgrey' : 'lightpink';  
		$html .=	'<div id="id2" style="background-color:' . $bgc .';">
						<span>
					Sosa : ' . ' 3 ' . 'Gen= ' . ' 2 ' .
							'<a class="" href="' . $person3->getHtmlUrl() . '">' . strip_tags($person3->getFullName() ) . 
							'</a> (' . $person3->getLifeSpan() . 
					')</span>
				</div>';
				} else {
					$bgc = 'white';
		$html .=	'<div id="id1" style="background-color:' . $bgc .';">
					<span>
					Sosa : ' . ' 3 ' . 'Gen= ' . ' 2 ' .
					'</span>
				</div>';	
				}
				
		$html .=	'</td></tr>				
				</table>
				</div>'; //end .htable
				
		// save file
		$tmp_dir = WT_DATA_DIR . 'tmp-' . $WT_TREE->getName() . '/';
		$tmp_file = 'sosa.html';
		
		if (!File::mkdir($tmp_dir)) {
			echo "Error : Could not create temporary path!";
			return;
		}

		$file = $tmp_dir . $tmp_file;
		$handle = fopen($file, 'w+');	
		fwrite($handle, $html);
		fclose($handle);		
		
		$html .= '
		<div class="overlay" style="display:none;"></div>	
			<div id="sosawait" class="popup_block">
				<p>' . I18N::translate('Wait, please...') .'</p>
				<img src="' . WT_MODULES_DIR . $this->getName() . '/images/progress2.gif" class="imgwait"/> 
			</div>
		';
		
	return $html;	
	}
	
	
	private function getHtmlSosaFooter(){
		global $WT_TREE;
		return '
				<div class="footer">
					<a href="' . $WT_TREE->getTitleHtml() . '&nbsp' .  "\t" . 'Module ' .  $this->getName() .' AD 2018 ' ."\t" .  strip_tags($WT_TREE->getTitleHtml()) . '</a>
				</div>
		
		';
	}
	
	private function setSosaPages($asc, $s){
		global $WT_TREE;
		
		//What list?
		switch ($s) {
			case '4':
				$ascs = $asc['gpFF'];
			break;
			case '5':
				$ascs = $asc['gpMF'];
			break;
			case '6':
				$ascs = $asc['gpFM'];
			break;	
			case '7':
				$ascs = $asc['gpMM'];
			break;	
			case '1':
				$ascs = $asc;
			break;	
		}
		
		
		
		$html = '<div class="hdata"><ul>';
		if (!null == $ascs){
		foreach ($ascs as $sosa => $xref){
				$person = Individual::getInstance($xref, $WT_TREE);
				if ( $person->getBirthPlace() != ''){
					$pl = explode(',', $person->getBirthPlace() );
					$pl = $pl[0] . ', ' . end($pl);
				} else {
					$pl = ' ? ';
				}
				$lf = $this->getLifespan($person);
				if ($sosa > 1){
				$gen = sosaClass::getSosaGeneration($sosa);
				} else {
					$gen = 1;
				}
				
				
				if ($sosa == $s) {
					//grand père
					$html .= '<div class="gptitle"><b><i>Gen: ' . $gen . ' Sosa = ' . $sosa .' : </i></b>&nbsp
								<b><i>' . $person->getFullName() . '&nbsp '. $lf . ' &nbsp &nbsp °' . $pl . '</i></b>
								</div>
							<p></p>' ;
						continue;
				}
				
					$html .= '<li><b><i>Gen: ' . $gen . ' Sosa = ' . $sosa .' : </i></b>
						 <a href="' . $person->getHtmlUrl() . '" title="sosa = ' . $sosa . '"><i class="">' . $person->getFullName() . '</i>- &nbsp ' . 
						 $lf . '</a>' .
						 ' &nbsp ° ' . $pl .
						'</li>';
		}
		}
		$html .= '</ul></div>'; //end hdata 
		
		// save file
		$tmp_dir = WT_DATA_DIR . 'tmp-' . $WT_TREE->getName() . '/';
		$tmp_file = 'sosa.html';
		
		if (!File::mkdir($tmp_dir)) {
			echo "Error : Could not create temporary path!";
			return;
		}

		$file = $tmp_dir . $tmp_file;
		$handle = fopen($file, 'a+');	
		fwrite($handle, $html);
		fclose($handle);

		
	return $html;
	}
	
	private function getLifespan(Individual $person){
		global $WT_TREE;
		if ( ($by = $person->getBirthYear() ) != ''){
			$html = '(' . $by . '-' ;
		} else {
			$html = '(?-';
		}
		if ($person->isDead() && (($dy = $person->getDeathYear()) != '') ){
			$html .= $dy . ')';
		} else {
			$html .= '?)';
		}
	return $html;
	}
/////////////////// Header ///////////////////

}
